module OneMultiplicity where

import FoulkesMultiplicities

import Data.List
import qualified Data.Map as M

-- To compute a particular Foulkes multiplicity

subpartitions []         = [[]]
subpartitions xs@(x : _) = [filter (/= 0) p | p <- subpartitionsBounded xs x]

subpartitionsBounded [] _ = [[]]
subpartitionsBounded (x : xs) b = [y : ys | y <- [0..x `min` b], ys <- subpartitionsBounded xs (y `min` b)]

subpartitionsSizeMultiple m xs = [ys | ys <- subpartitions xs, sum ys `mod` m == 0]

oneMultiplicity m xs =
    let fmap = M.fromList [(ys, f ys) | ys <- subpartitionsSizeMultiple m xs]
        f [] = 1
        f ys = let n' = sum ys `div` m
               in  sum [s * fmap M.! ys' | l <- [1..n'], (ys', s) <- removeHooksP m l ys, length ys' <= n'-l] `div` (toInteger n')        
    in  fmap M.! xs
    
check n m = [(xs, t) | xs <- partitions (m * n), let t = oneMultiplicity m xs, t > 0]    

testPartition = [9] ++ [3 | i <- [1..35]] :: Partition
testSubpartitions = subpartitionsSizeMultiple 6 testPartition